
'=====================================================
'                                                    '
'        ---------------------------------           '                                                  
'           CustomWindow.inc (Version 2)             '
'        ---------------------------------           '
'                                                    '
'     This include file will let you create a        ' 
'                 custom window.                     '
'                                                    '
'                    By Andy.                        '
'                                                    '
'=====================================================

$use "customwindowlib.lib"

'Minimise and close images.
uint cwMinOn = loadimage(getstartpath + "minon.jpg",@IMGSCALABLE)
uint cwMinOff = loadimage(getstartpath + "minoff.jpg",@IMGSCALABLE)
uint cwCloseOn = loadimage(getstartpath + "closeon.jpg",@IMGSCALABLE)
uint cwCloseoff = loadimage(getstartpath + "closeoff.jpg",@IMGSCALABLE)

'Library external routines.
declare extern CreateCaption(window WinIn,int CaptionID,string CaptionIn,int MinIn,int CloseIn),int
declare extern CreateBorder(window WinIn,int IconIn,opt uint ColorIn),int
declare extern MyMenuTitle(string ButText,int ControlID),int
declare extern MyMenuItem(string ButText,int ControlID,opt int ControlIcon,opt int StyleIn,opt int ColorFIn,opt int ColorBIn),int
declare extern MyPopupTitle(string ButText,int ControlID,opt int ControlIcon,opt int StyleIn,opt int ColorFIn,opt int ColorBIn),int
declare extern MyPopupEnd(),int
declare extern MyPopupItem(string ButText,int ControlID,opt int ControlIcon,opt int StyleIn,opt int ColorFIn,opt int ColorBIn),int
declare extern MySeparator(int ControlID),int
declare extern MyMenuUpdate(window WinIn),int
declare extern MyMenuEnd(),int
declare extern HighlightMenuItems(window WinIn),int
declare extern ShowMenuItems(window WinIn,int MenuID),int
declare extern HideMenuItems(window WinIn,int MenuID),int
declare extern MenuClicked(window WinIn,int MenuID),int
declare extern HideAllMenuItems(window WinIn),int
declare extern EnableControls(window WinIn)
declare extern MenuChanged(window WinIn),int
declare extern MenuClickOff(window WinIn),int
declare extern MenuCheck(window WinIn),int
declare extern ExtractResource(id:INT, restype:INT, filename:STRING)

'Library external variables.
EXTERN cwPictureWidth as int  : cwPictureWidth = 36
EXTERN cwPictureHieght as int : cwPictureHieght = 26
EXTERN cwMenuItm as int : cwMenuItm = cwPictureHieght
EXTERN cwCaptionPosition as INT : cwCaptionPosition = cwPictureWidth
EXTERN cwAcross as int : cwAcross = 10
EXTERN cwl,cwt,cww,cwh AS INT                  
EXTERN cwYloop AS INT
EXTERN cwZloop AS INT
EXTERN cwMinPos AS INT
EXTERN cwClosePos AS INT
EXTERN cwMyControlsBeginAt AS INT
EXTERN cwMyControlsEndAt AS INT
EXTERN cwCaptionWidth AS INT
EXTERN cwMenuCount AS INT
EXTERN cwItemCount AS INT
EXTERN cwTotalMenuItems AS INT
EXTERN cwSeparatorItems AS INT
EXTERN cwMenuItems AS INT
EXTERN cwMenus[100] AS INT
EXTERN cwMenuTitles[100,1000] AS INT
EXTERN cwMenuItemT[1000] AS INT
EXTERN cwMenuItemD[100,1000] AS INT
EXTERN cwMenuItemDtype[100,1000] AS INT
extern cwMenuItemStyle[1000] as int
extern cwMenuItemFg[1000] as int
extern cwMenuItemBg[1000] as int
extern cwMenuItemFgD[100,1000] as int
extern cwMenuItemBgD[100,1000] as int
EXTERN cwMenuItemI[100,1000] AS INT
EXTERN cwMenuPopup[100,1000] AS INT
EXTERN cwMenuItemParent[100,1000] AS INT
EXTERN cwMenuItemShow[100,1000] AS INT
EXTERN cwMenuPopupCount AS INT
EXTERN cwMenuItemType[1000] AS INT
EXTERN cwPopupShowing[1000] AS INT
EXTERN cwPopupShowingCount AS INT
EXTERN cwPopupHide AS INT
EXTERN cwNotOver AS INT
EXTERN cwMenuClick[1000] AS INT
EXTERN cwMenuHighlted[1000] AS INT
EXTERN cwLongestMenuItem AS INT
EXTERN cwMenupopups AS INT
EXTERN cwMenuIcon AS INT
EXTERN cwDisplayItems AS INT
EXTERN cwDisplayOver AS INT
EXTERN cwShowingMenu AS INT
EXTERN cwShowingParent AS INT
EXTERN cwa,cwb,cwpop1 as int
EXTERN cwPopitm AS INT
EXTERN cwMenuStore AS INT
EXTERN cwPreviousMouseOver AS INT
EXTERN cwCurrentTitle AS INT
EXTERN cwCurrentPopup AS INT
EXTERN cwMenuItemText[1000] AS string
extern cwCurrentWindow as window

sub CheckWindow(window WinIn,int MinIn,int CloseIn),int

	  'Detect if the mouse is over the minimise box or not.
	  if MouseOver(WinIn,MinIn)
		  showimage WinIn,cwMinOn,@IMGSCALABLE,cwMinPos,1
	  else
		  showimage WinIn,cwMinOff,@IMGSCALABLE,cwMinPos,1
	  endif

	  'Detect if the mouse is over the close box or not.
	  if MouseOver(WinIn,CloseIn)
		  showimage WinIn,cwCloseOn,@IMGSCALABLE,cwClosePos,1
	  else
		  showimage WinIn,cwCloseOff,@IMGSCALABLE,cwClosePos,1
	  endif

	  'Minimised clicked.
	  if ControlClick(WinIn,MinIn)
		  showwindow WinIn,@SWMINIMIZED
	  endif

	  'Close window clicked.
	  if ControlClick(WinIn,CloseIn)
		  stoptimer WinIn
		  closewindow WinIn
	  endif

     MenuCheck(WinIn)

return 0
endsub

'Delete custom window images when closing a window.
sub CloseCaption(),int
if cwCloseOn  then deleteimage cwCloseOn,@IMGSCALABLE
if cwCloseOff then deleteimage cwCloseOff,@IMGSCALABLE
if cwMinOn    then deleteimage cwMinOn,@IMGSCALABLE
if cwMinOff   then deleteimage cwMinOff,@IMGSCALABLE 
return 0
endsub

